
package control;

import java.io.IOException;
import java.io.PrintWriter;
import java.sql.SQLException;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import model.SanPham;
import model.ThongTinSanPham;


public class ProductByCategory extends HttpServlet {
	private static final long serialVersionUID = 2L;
    /** 
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        request.setCharacterEncoding("UTF-8");
	    response.setCharacterEncoding("UTF-8");
        PrintWriter out = response.getWriter();
        try {
        	SanPham c = new SanPham();
        	String PagePresent = (String)request.getParameter("page");
        	if (PagePresent==null ){PagePresent= "1";}
           int pageNumber = Integer.parseInt(PagePresent);
            String category = request.getParameter("category");
           if (category != null){
            String cateshoww =	category.replaceAll("%20", " ");
            cateshoww = cateshoww.replaceAll("[%']", "");
            cateshoww = cateshoww.replaceAll("Đ", "D");
            cateshoww = cateshoww.replaceAll("đ", "d");
            category= new SanPham().UTFToASCI(cateshoww);
            
            int TongRecords =   c.recordsbycategory(category);
            int pagen = TongRecords / 9;
            if((TongRecords % 9) != 0) {
                pagen++;
            }
            if (pageNumber < 1 || pageNumber > pagen ){pageNumber = 1;}
            int limit = 9;
            int offset = TongRecords - pageNumber*9;
            if (offset < 0){ offset = 0; limit = TongRecords - (pageNumber-1)*9;}        
            
            List<ThongTinSanPham> sanpham = c.byCategory(limit, offset, category);          
            request.setAttribute("sanpham", sanpham);
            request.setAttribute("recordbycategory", pagen);


            RequestDispatcher rd = request.getRequestDispatcher("index.jsp?main=category&category="+category+"&page="+pageNumber);
            rd.forward(request, response);
        } else {
        	response.sendRedirect("index.jsp");
        }}
           
           catch (SQLException ex) {
            Logger.getLogger(Process.class.getName()).log(Level.SEVERE, null, ex);
        } finally {
            out.close();
        }
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>
}
